/*

	ent-ghost
	Copyright [2011-2013] [Jack Lu1]

	This file is part of the ent-ghost source code.

	ent-ghost is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	ent-ghost source code is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with ent-ghost source code. If not, see <http://www.gnu.org/licenses/>.

	ent-ghost is modified from GHost++ (http://ghostplusplus.googlecode.com/)
	GHost++ is Copyright [2008] [Trevor Hogan]

*/

#ifndef KEYCLIENT_H
#define KEYCLIENT_H

//
// CKeyClient
//

class CTCPClient;
class CKeyProtocol;
class CCommandPacket;

class CKeyClient
{
private:
	CTCPClient *m_Socket;							// the connection to the key server
	CKeyProtocol *m_Protocol;						// key protocol
	queue<CCommandPacket *> m_Packets;				// queue of incoming packets
	bool m_Connected;
	string m_Server;
	uint16_t m_Port;
	string m_RealmServer;
	bool m_TFT;
	string m_Token;
	uint32_t m_LastNullTime;
	queue<BYTEARRAY> m_OutPackets;					// queue of outgoing packets to be sent
	string m_CDKeyROC;
	string m_CDKeyTFT;
	uint32_t m_LastRequestTime;

	uint32_t m_LastDisconnectedTime;				// GetTime when we were last disconnected from battle.net
	uint32_t m_LastConnectionAttemptTime;			// GetTime when we last attempted to connect to battle.net

public:
	CKeyClient( string nServer, uint16_t nPort, string nRealmServer, bool nTFT, string nToken );
	~CKeyClient( );

	void MakeRequest( );
	bool IsReady( );
	void Reset( );
	string GetCDKeyROC( )		{ return m_CDKeyROC; }
	string GetCDKeyTFT( )		{ return m_CDKeyTFT; }

	// processing functions

	unsigned int SetFD( void *fd, void *send_fd, int *nfds );
	void Update( void *fd, void *send_fd );
	void ExtractPackets( );
	void ProcessPackets( );
};

#endif
