/*

	ent-ghost
	Copyright [2011-2013] [Jack Lu1]

	This file is part of the ent-ghost source code.

	ent-ghost is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	ent-ghost source code is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with ent-ghost source code. If not, see <http://www.gnu.org/licenses/>.

	ent-ghost is modified from GHost++ (http://ghostplusplus.googlecode.com/)
	GHost++ is Copyright [2008] [Trevor Hogan]

*/

#ifndef KEYPROTOCOL_H
#define KEYPROTOCOL_H

//
// CKeyProtocol
//

class CKeyInfo;

class CKeyProtocol
{
public:
	enum Protocol {
		KEY_NULL     = 0,
		KEY_AUTH     = 1,
		KEY_OBTAIN   = 2
	};

public:
	CKeyProtocol( );
	~CKeyProtocol( );

	// receive functions

	CKeyInfo *RECEIVE_KEY_OBTAIN( BYTEARRAY data );

	// send functions

	BYTEARRAY SEND_KEY_NULL( );
	BYTEARRAY SEND_KEY_AUTH( string token );
	BYTEARRAY SEND_KEY_OBTAIN( string server, string type );

	// other functions

private:
	bool AssignLength( BYTEARRAY &content );
	bool ValidateLength( BYTEARRAY &content );
};



//
// CKeyInfo
//
	
class CKeyInfo
{
private:
	string m_Server;
	string m_Type;
	string m_Key;

public:
	CKeyInfo( string nServer, string nType, string nKey );
	~CKeyInfo( );

	string GetServer( )		{ return m_Server; }
	string GetType( )		{ return m_Type; }
	string GetKey( )		{ return m_Key; }
};

#endif
