CREATE TABLE IF NOT EXISTS `notes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `server` varchar(100) NOT NULL,
  `name` varchar(15) NOT NULL,
  `note` varchar(250) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;

ALTER TABLE `bans` ADD COLUMN `warn` INT(11) DEFAULT '0' NOT NULL;
ALTER TABLE `bans` ADD COLUMN `gamecount` INT DEFAULT '0' NOT NULL,
ALTER TABLE `admins` ADD COLUMN `access` BIGINT unsigned DEFAULT '4294963199' NOT NULL;

CREATE TABLE IF NOT EXISTS `ban_reports` (
  `player_id` int(11) NOT NULL,
  `player_name` varchar(25) NOT NULL,
  `user_id` int(11) NOT NULL,
  `user_ip` varchar(20) NOT NULL,
  `reason` varchar(255) NOT NULL,
  `game_url` varchar(200) NOT NULL,
  `replay_url` varchar(255) NOT NULL,
  `added` int(11) NOT NULL,
  `status` tinyint(4) NOT NULL,
  KEY `player_id` (`player_id`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `ban_appeals` (
  `player_id` int(11) NOT NULL,
  `player_name` varchar(25) NOT NULL,
  `user_id` int(11) NOT NULL,
  `user_ip` varchar(20) NOT NULL,
  `reason` varchar(255) NOT NULL,
  `game_url` varchar(200) NOT NULL,
  `replay_url` varchar(255) NOT NULL,
  `added` int(11) NOT NULL,
  `status` tinyint(4) NOT NULL,
  KEY `player_id` (`player_id`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `page` varchar(16) NOT NULL,
  `page_id` int(11) NOT NULL,
  `text` text NOT NULL,
  `date` int(11) NOT NULL,
  `user_ip` varchar(16) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM   ;

ALTER TABLE `games` ADD COLUMN `stats` tinyint(1) NOT NULL;
CREATE INDEX `stats` ON `games` (`stats`);
ALTER TABLE `dotagames` ADD COLUMN `stats` tinyint(1) NOT NULL;
CREATE INDEX `stats` ON `dotagames` (`stats`);
ALTER TABLE `games` ADD COLUMN `views` int(11) NOT NULL;

CREATE TABLE IF NOT EXISTS `heroes` (
  `heroid` varchar(4) NOT NULL,
  `original` varchar(4) NOT NULL,
  `description` varchar(32) NOT NULL,
  `summary` varchar(900) NOT NULL,
  `stats` varchar(300) NOT NULL,
  `skills` varchar(300) NOT NULL,
  `type` tinyint(4) NOT NULL,
  `voteup` int(11) NOT NULL DEFAULT '0',
  `votedown` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`heroid`),
  KEY `description` (`description`),
  KEY `original` (`original`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `items` (
  `itemid` varchar(4) NOT NULL,
  `code` smallint(10) NOT NULL,
  `name` varchar(50) NOT NULL,
  `shortname` varchar(50) NOT NULL,
  `item_info` mediumtext NOT NULL,
  `price` smallint(6) NOT NULL,
  `type` varchar(10) NOT NULL,
  `icon` varchar(50) NOT NULL,
  PRIMARY KEY (`itemid`),
  KEY `name` (`name`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `safelist` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `server` varchar(100) NOT NULL,
  `name` varchar(25) NOT NULL,
  `voucher` varchar(15) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM ;

CREATE TABLE IF NOT EXISTS `scores` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `category` varchar(25) NOT NULL,
  `name` varchar(15) NOT NULL,
  `server` varchar(100) NOT NULL,
  `score` double NOT NULL,
  PRIMARY KEY (`id`),
  KEY `name` (`name`),
  KEY `score` (`score`)
) ENGINE=MyISAM  ;


CREATE TABLE IF NOT EXISTS `stats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `player` varchar(30) CHARACTER SET utf8 NOT NULL,
  `score` int(11) NOT NULL,
  `games` int(11) NOT NULL,
  `wins` int(11) NOT NULL,
  `losses` int(11) NOT NULL,
  `draw` int(11) NOT NULL,
  `kills` int(11) NOT NULL,
  `deaths` int(11) NOT NULL,
  `assists` int(11) NOT NULL,
  `creeps` int(11) NOT NULL,
  `denies` int(11) NOT NULL,
  `neutrals` int(11) NOT NULL,
  `towers` int(11) NOT NULL,
  `rax` int(11) NOT NULL,
  `banned` tinyint(1) NOT NULL,
  `ip` varchar(16) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `score` (`score`)
) ENGINE=MyISAM  ;

CREATE TABLE IF NOT EXISTS `openstats_users` (
  `user_id` mediumint(8) NOT NULL AUTO_INCREMENT,
  `user_name` varchar(30) CHARACTER SET utf8 NOT NULL,
  `user_password` varchar(60) CHARACTER SET utf8 NOT NULL,
  `password_hash` varchar(65) NOT NULL,
  `user_email` varchar(60) CHARACTER SET utf8 NOT NULL,
  `user_joined` int(11) NOT NULL,
  `user_level` tinyint(1) NOT NULL,
  `user_last_login` int(11) NOT NULL,
  `user_ip` varchar(40) CHARACTER SET utf8 NOT NULL,
  `user_avatar` varchar(255) CHARACTER SET utf8 NOT NULL,
  `user_location` varchar(100) CHARACTER SET utf8 NOT NULL,
  `user_realm` varchar(255) CHARACTER SET utf8 NOT NULL,
  `user_website` varchar(255) CHARACTER SET utf8 NOT NULL,
  `user_gender` tinyint(4) NOT NULL,
  `user_fbid` varchar(30) CHARACTER SET utf8 NOT NULL,
  `can_comment` tinyint(4) NOT NULL DEFAULT '1',
  `code` varchar(15) CHARACTER SET utf8 NOT NULL,
  `confirm` varchar(65) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`user_id`),
  UNIQUE KEY `user_name` (`user_name`),
  KEY `last_login` (`user_last_login`),
  KEY `joined` (`user_joined`),
  KEY `confirm` (`confirm`)
) ENGINE=MyISAM  ;

CREATE TABLE IF NOT EXISTS `news` (
  `news_id` mediumint(8) NOT NULL AUTO_INCREMENT,
  `news_title` varchar(255) CHARACTER SET utf8 NOT NULL,
  `news_content` mediumtext CHARACTER SET utf8 NOT NULL,
  `news_date` int(11) NOT NULL,
  `news_updated` int(11) NOT NULL,
  `views` int(11) NOT NULL,
  `status` tinyint(4) NOT NULL,
  PRIMARY KEY (`news_id`),
  KEY `status` (`status`)
) ENGINE=MyISAM  ;

CREATE TABLE IF NOT EXISTS `permissions` (
  `name` varchar(255) NOT NULL,
  `value` tinyint(4) NOT NULL,
  `user_group` tinyint(4) NOT NULL,
  KEY `name` (`name`),
  KEY `group` (`user_group`)
) ENGINE=MyISAM ;


INSERT INTO `permissions` (`name`, `value`, `user_group`) VALUES
('can_edit_posts', 1, 2),
('can_write_posts', 1, 2),
('can_delete_posts', 1, 2),
('can_manage_games', 1, 2),
('can_delete_games', 1, 2),
('can_edit_bans', 1, 2),
('can_add_bans', 1, 2),
('can_delete_bans', 1, 2),
('manage_heroes_items', 1, 2),
('can_edit_admins', 1, 2),
('can_add_admins', 1, 2),
('can_delete_admins', 1, 2),
('can_write_comments', 1, 2),
('manage_comments', 1, 2),
('manage_users', 1, 2),
('user_permissions', 1, 2),
('configuration', 0, 2),
('can_edit_posts', 1, 1),
('can_write_posts', 1, 1),
('can_delete_posts', 1, 1),
('can_manage_games', 0, 1),
('can_delete_games', 0, 1),
('can_edit_bans', 0, 1),
('can_add_bans', 0, 1),
('can_delete_bans', 0, 1),
('manage_heroes_items', 0, 1),
('can_edit_admins', 0, 1),
('can_add_admins', 0, 1),
('can_delete_admins', 0, 1),
('can_write_comments', 1, 1),
('manage_comments', 0, 1),
('manage_users', 0, 1),
('user_permissions', 0, 1),
('configuration', 0, 1),
('can_edit_posts', 0, 0),
('can_write_posts', 0, 0),
('can_delete_posts', 0, 0),
('can_manage_games', 0, 0),
('can_delete_games', 0, 0),
('can_edit_bans', 0, 0),
('can_add_bans', 0, 0),
('can_delete_bans', 0, 0),
('manage_heroes_items', 0, 0),
('can_edit_admins', 0, 0),
('can_add_admins', 0, 0),
('can_delete_admins', 0, 0),
('can_write_comments', 1, 0),
('manage_comments', 0, 0),
('manage_users', 0, 0),
('user_permissions', 0, 0),
('configuration', 0, 0),
('can_write_comments', 1, 9),
('can_delete_admins', 1, 9),
('can_add_admins', 1, 9),
('can_edit_admins', 1, 9),
('manage_heroes_items', 1, 9),
('can_delete_bans', 1, 9),
('can_add_bans', 1, 9),
('can_edit_bans', 1, 9),
('can_delete_games', 1, 9),
('can_manage_games', 1, 9),
('can_delete_posts', 1, 9),
('can_write_posts', 1, 9),
('can_edit_posts', 1, 9),
('manage_comments', 1, 9),
('manage_users', 1, 9),
('user_permissions', 1, 9),
('configuration', 1, 9);
