<?php

include("../include/common.php");
include("../config.php");
include("../include/session.php");
include("../include/dbconnect.php");

include("../include/account.php");
include("../include/auth.php");

if(isset($_SESSION['account_id']) && isset($_REQUEST['id'])) {
	$service_id = $_REQUEST['id'];
	if(isServiceAccount($service_id, $_SESSION['account_id'])) {
		if(!isServiceSuspended($service_id)) {
			$service_info = getService($service_id);
			$_SESSION['is_' . $service_id . '_' . $service_info['type']] = true;

			//check if we need to redirect to a slave uxpanel instance
			$slaveRedirect = getServiceParam($service_id, "slave");

			if(!$config['slave_enabled'] && $slaveRedirect != false) {
				//ok, register stuff into database and redirect to the other instance
				$ip = $_SERVER['REMOTE_ADDR'];
				$token = authRemoteRegister($_SESSION['account_id'], $service_id, $ip);

				uxRedirect($slaveRedirect . "remote_login.php?user_id={$_SESSION['account_id']}&service_id=$service_id&ip=" . urlencode($ip) . "&token=$token");
			} else {
				uxRedirect("../{$service_info['type']}/?id=$service_id");
			}
		} else {
			uxRedirect('services.php?message=' . urlencode('The specified service is suspended. Please either make a payment, or contact support if this is unexpected. Note that payments are processed manually and may take one business day to be reflected on your account.'));
		}
	} else {
		uxRedirect('services.php?message=' . urlencode('The specified service does not exist.'));
	}
} else {
	uxRedirect("../");
}

?>
