<?php

if(php_sapi_name() !== 'cli') {
	die("Access forbidden.");
}

include("include/common.php");
include("config.php");
include("include/dbconnect.php");

include("include/account.php");
include("include/database.php");

$realms = array("useast.battle.net", "uswest.battle.net", 'europe.battle.net', 'asia.battle.net');

foreach($realms as $realm) {
	$result = $db->query("SELECT id, email, name, tag, usernames, passwords FROM services_cron_clan WHERE realm = '$realm' ORDER BY id LIMIT 1");

	if($row = $result->fetch_array()) {
		$db->query("DELETE FROM services_cron_clan WHERE id = '{$row[0]}'");
		
		$realm_short = $realm;
		
		if($realm == "useast.battle.net") {
			$realm_short = "useast";
		} else if($realm == "uswest.battle.net") {
			$realm_short = "uswest";
		} else if($realm == "europe.battle.net") {
			$realm_short = "europe";
		} else if($realm == "asia.battle.net") {
			$realm_short = "asia";
		}
	
		$email = $row[1];
		$name = $row[2];
		$tag = $row[3];
		$usernames = explode(",", $row[4]);
		$passwords = explode(",", $row[5]);
		
		if(count($usernames) != 10 || count($passwords) != 10) {
			$message = "Clan creation failure - usernames or passwords count not equal to ten!";
		} else {
			$message = "The clan [$name] with tag [$tag] has been created. Accounts with randomly generated passwords appear below (keep in mind that passwords are NOT case sensitive).\n\n";
			$default_password = "";
			$log_id = uid(6);
			$channel = "lgservices" . $log_id;
			
			if(file_exists("/lg/services/pychop/{$realm_short}counter.txt")) {
				$counter = file_get_contents("/lg/services/pychop/{$realm_short}counter.txt");
			} else {
				$counter = 0;
			}
			
			file_put_contents("/lg/services/pychop/{$realm_short}counter.txt", ($counter + 1) % 6);
			
			$confmap = array();
			for($i = 0; $i < 10; $i++) {
				if($i == 0) {
					if($counter == 0) {
						$confmap[$i] = 0;
					} else {
						$confmap[$i] = $counter + 9;
					}
				} else {
					$confmap[$i] = $i;
				}
				
				//make sure PID file exists and is valid
				$fin = @fopen("/lg/services/pychop/{$realm_short}{$confmap[$i]}.pid", 'r');
		
				if($fin) {
					$pid = trim(fgets($fin, 4096));
					fclose($fin);
			
					$result = exec("cat /proc/$pid/cmdline");
					if(stripos($result, 'chop') === false) {
						echo "Failed to find pid for {$realm_short}{$confmap[$i]}\n";
						die("PID find failed -- {$realm_short}{$confmap[$i]}\n");
					}
				}
			}
			
			//rewrite configurations and kill old bots
			for($i = 0; $i < 10; $i++) {
				$fin = @fopen("/lg/services/pychop/{$realm_short}{$confmap[$i]}.cfg", 'r');
				$fout = @fopen("/lg/services/pychop/{$realm_short}{$confmap[$i]}.cfg_", 'w');
		
				if(empty($passwords[$i])) {
					if(empty($default_password)) {
						$passwords[$i] = uid(15);
						$message .= "* " . $usernames[$i] . " -- " . $passwords[$i] . "\n";
					}
				}

				while(($line = fgets($fin, 4096)) !== false) {
					if(strpos($line, "bnet_username") !== false) {
						fwrite($fout, "bnet_username = " . $usernames[$i] . "\n");
					} else if(strpos($line, "bnet_password") !== false) {
						fwrite($fout, "bnet_password = " . $passwords[$i] . "\n");
					} else if(strpos($line, "bnet_registername") !== false) {
						fwrite($fout, "bnet_registername = " . $usernames[$i] . "\n");
					} else if(strpos($line, "bnet_registerpassword") !== false) {
						fwrite($fout, "bnet_registerpassword = " . $passwords[$i] . "\n");
					} else if(strpos($line, "p_lgclan_usernames") !== false) {
						fwrite($fout, "p_lgclan_usernames = {$usernames[1]} {$usernames[2]} {$usernames[3]} {$usernames[4]} {$usernames[5]} {$usernames[6]} {$usernames[7]} {$usernames[8]} {$usernames[9]}\n");
					} else if(strpos($line, "bnet_firstchannel") !== false) {
						fwrite($fout, "bnet_firstchannel = " . $channel . "\n");
					} else if(strpos($line, "p_lgclan_name") !== false) {
						fwrite($fout, "p_lgclan_name = " . $name . "\n");
					} else if(strpos($line, "p_lgclan_tag") !== false) {
						fwrite($fout, "p_lgclan_tag = " . $tag . "\n");
					} else if(strpos($line, "bot_log") !== false) {
						fwrite($fout, "bot_log = logs/$tag.$log_id.{$realm_short}{$i}.log\n");
					} else if(strpos($line, "p_pluginman_plugins") !== false) {
						if($i == 0) {
							fwrite($fout, "p_pluginman_plugins = lg_clan\n");
						} else {
							fwrite($fout, "p_pluginman_plugins = lg_clan_slave\n");
						}
					} else {
						fwrite($fout, $line);
					}
				}
		
				fclose($fin);
				fclose($fout);
		
				$fin = @fopen("/lg/services/pychop/{$realm_short}{$confmap[$i]}.pid", 'r');
		
				if($fin) {
					$pid = trim(fgets($fin, 4096));
					fclose($fin);
			
					$result = exec("cat /proc/$pid/cmdline");
					if(stripos($result, 'chop') !== false) {
						exec("kill -s INT $pid");
					} else {
						echo "Failed to find pid for {$realm_short}{$confmap[$i]}\n";
					}
				}
			}
	
			sleep(1);
	
			//startup new bots
			for($i = 0; $i < 10; $i++) {
				$pid = execBackground("cd /lg/services/pychop && nohup ./chop++ {$realm_short}{$confmap[$i]}.cfg_ > /dev/null 2>&1 & echo $!");
				$fout = @fopen("/lg/services/pychop/{$realm_short}{$confmap[$i]}.pid", 'w');
				fwrite($fout, $pid);
				fclose($fout);
			}
	
			// wait for clan to create in 60 seconds
			sleep(60);
	
			//restart the bots with default configurations
			for($i = 0; $i < 10; $i++) {
				$fin = @fopen("/lg/services/pychop/{$realm_short}{$confmap[$i]}.pid", 'r');
		
				if($fin) {
					$pid = trim(fgets($fin, 4096));
					fclose($fin);
			
					$result = exec("cat /proc/$pid/cmdline");
					if(stripos($result, 'chop') !== false) {
						exec("kill -s INT $pid");
					}
				}
			}
			
			sleep(1);
	
			for($i = 0; $i < 10; $i++) {
				$pid = execBackground("cd /lg/services/pychop && nohup ./chop++ {$realm_short}{$confmap[$i]}.cfg > /dev/null 2>&1 & echo $!");
				$fout = @fopen("/lg/services/pychop/{$realm_short}{$confmap[$i]}.pid", 'w');
				fwrite($fout, $pid);
				fclose($fout);
			}
			
			$message .= "\n\nNote: if your clan did not create successfully, contact us and include your log file ID *$log_id*.";
		}
	
		//send notification email
		require_once "Mail.php";

		$host = "yandex@vendevpanel.net";
		$port = 465;
		$username = 'VenDev';
		$password = '2LzKFoWQ3OhRf6KD';
		$headers = array ('From' => 'support@VenDevpanel.net',
						  'To' => $email,
						  'BCC' => 'support@VenDevpanel.net',
						  'Subject' => "[VenDev] Clan creation notification",
						  'Content-Type' => 'text/plain');
		$smtp = Mail::factory('smtp',
							  array ('host' => $host,
									 'port' => $port,
									 'auth' => true,
									 'username' => $username,
									 'password' => $password));
	
		$mail = $smtp->send("$email, support@VenDevpanel.net", $headers, $message);
	}
}

?>
